package com.jisco.dynamicweight.dynamicbasescdbconfig.controller;

import cn.hutool.core.lang.Assert;
import com.jisco.dynamicweight.dynamicbasescdbconfig.model.DynamicBaseScdbConfig;
import com.jisco.dynamicweight.dynamicbasescdbconfig.service.IDynamicBaseScdbConfigService;
import com.jisco.dynamicweight.util.ExcelUtil;
import com.jisco.dynamicweight.util.UserUtil;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

/**
 * DynamicBaseScdbConfig RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-01-06 05:25
 * 类描述
 * 修订历史：
 * 日期：2022-01-06
 * 作者：generator
 * 参考：
 * 描述：DynamicBaseScdbConfig RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/dynamicbasescdbconfigs")
public class DynamicBaseScdbConfigController extends BaseRESTfulController {

    @Autowired
    IDynamicBaseScdbConfigService dynamicBaseScdbConfigService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("dynamicbasescdbconfig:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<DynamicBaseScdbConfig> list = dynamicBaseScdbConfigService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("dynamicbasescdbconfig:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<DynamicBaseScdbConfig> list = dynamicBaseScdbConfigService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据DynamicBaseScdbConfig对象创建")
    @ApiImplicitParam(name = "dynamicBaseScdbConfig", value = "详细实体dynamicBaseScdbConfig", required = true, dataType = "DynamicBaseScdbConfig")
    //@RequiresPermissions("dynamicbasescdbconfig:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody DynamicBaseScdbConfig model){
        Assert.isTrue(StringUtils.isNotBlank(model.getName()), "请输入名称!");
        Assert.isTrue(StringUtils.isNotBlank(model.getUrl()), "请输入连接字符串!");
        Assert.isTrue(StringUtils.isNotBlank(model.getUsername()), "请输入用户名!");
        Assert.isTrue(StringUtils.isNotBlank(model.getPassword()), "请输入密码!");
        Assert.isTrue(StringUtils.isNotBlank(model.getTableName()), "请输入表名!");
        Assert.isTrue(StringUtils.isNotBlank(model.getValidFlag()), "有效标识不能为空!");
        model.setCreateManNo(UserUtil.getCurrentUserId());
        model.setCreateManName(UserUtil.getCurrentUserName());
        model.setCreateTime(new Date());
        DynamicBaseScdbConfig dynamicBaseScdbConfig = dynamicBaseScdbConfigService.add(model);
        return success(dynamicBaseScdbConfig);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("dynamicbasescdbconfig:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        DynamicBaseScdbConfig dynamicBaseScdbConfig = dynamicBaseScdbConfigService.getById(id);
        return success(dynamicBaseScdbConfig);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的dynamicBaseScdbConfig信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "dynamicBaseScdbConfig", value = "详细实体dynamicBaseScdbConfig", required = true, dataType = "DynamicBaseScdbConfig")
    })
    //@RequiresPermissions("dynamicbasescdbconfig:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody DynamicBaseScdbConfig model){
        Assert.isTrue(StringUtils.isNotBlank(model.getName()), "请输入名称!");
        Assert.isTrue(StringUtils.isNotBlank(model.getUrl()), "请输入连接字符串!");
        Assert.isTrue(StringUtils.isNotBlank(model.getUsername()), "请输入用户名!");
        Assert.isTrue(StringUtils.isNotBlank(model.getPassword()), "请输入密码!");
        Assert.isTrue(StringUtils.isNotBlank(model.getTableName()), "请输入表名!");
        Assert.isTrue(StringUtils.isNotBlank(model.getValidFlag()), "有效标识不能为空!");
        model.setId(id);
        model.setUpdateManNo(UserUtil.getCurrentUserId());
        model.setUpdateManName(UserUtil.getCurrentUserName());
        model.setUpdateTime(new Date());
        DynamicBaseScdbConfig dynamicBaseScdbConfig = dynamicBaseScdbConfigService.modify(model);
        return success(dynamicBaseScdbConfig);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("dynamicbasescdbconfig:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  dynamicBaseScdbConfigService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value = "导出Excel", notes = "导出Excel")
    @PostMapping(value = "/exportExcel")//String
    public void exportExcel(HttpServletResponse response) throws IOException {
        List<DynamicBaseScdbConfig> list = dynamicBaseScdbConfigService.query(null);
        ExcelUtil.exportExcel(response, list, DynamicBaseScdbConfig.class, "动态秤日报数据库配置信息");
    }
}
